#include "ruby-spml.h"

#ifdef IFORT
extern double* esc_module_mp_x_x_;
extern double* esc_module_mp_x_x_weight_;
extern double* esc_module_mp_y_y_;
extern double* esc_module_mp_y_y_weight_;
extern double* esc_module_mp_yx_x_;
extern double* esc_module_mp_yx_y_;
extern void esc_module_mp_esc_initial_(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* esc_module_mp_yx_es_(struct farray*, double*);
extern struct farray* esc_module_mp_yx_ec_(struct farray*, double*);
extern struct farray* esc_module_mp_es_yx_(struct farray*, double*);
extern struct farray* esc_module_mp_ec_yx_(struct farray*, double*);
extern struct farray* esc_module_mp_es_lapla_es_(struct farray*, double*);
extern struct farray* esc_module_mp_ec_lapla_ec_(struct farray*, double*);
extern struct farray* esc_module_mp_es_laplainv_es_(struct farray*, double*);
extern struct farray* esc_module_mp_ec_laplainv_ec_(struct farray*, double*);
extern struct farray* esc_module_mp_es_dx_es_(struct farray*, double*);
extern struct farray* esc_module_mp_ec_dx_ec_(struct farray*, double*);
extern struct farray* esc_module_mp_ec_dy_es_(struct farray*, double*);
extern struct farray* esc_module_mp_es_dy_ec_(struct farray*, double*);
extern struct farray* esc_module_mp_es_jacobian_es_es_(struct farray*, double*, double*);
extern struct farray* esc_module_mp_ec_jacobian_es_ec_(struct farray*, double*, double*);
extern double esc_module_mp_intyx_yx_(double*);
extern struct farray* esc_module_mp_y_intx_yx_(struct farray*, double*);
extern struct farray* esc_module_mp_x_inty_yx_(struct farray*, double*);
extern double esc_module_mp_intx_x_(double*);
extern double esc_module_mp_inty_y_(double*);
extern double esc_module_mp_avryx_yx_(double*);
extern struct farray* esc_module_mp_y_avrx_yx_(struct farray*, double*);
extern struct farray* esc_module_mp_x_avry_yx_(struct farray*, double*);
extern double esc_module_mp_avrx_x_(double*);
extern double esc_module_mp_avry_y_(double*);
#endif
#ifdef GFORTRAN
extern double* __esc_module_MOD_x_x;
extern double* __esc_module_MOD_x_x_weight;
extern double* __esc_module_MOD_y_y;
extern double* __esc_module_MOD_y_y_weight;
extern double* __esc_module_MOD_yx_x;
extern double* __esc_module_MOD_yx_y;
extern void __esc_module_MOD_esc_initial(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* __esc_module_MOD_yx_es(struct farray*, double*);
extern struct farray* __esc_module_MOD_yx_ec(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_yx(struct farray*, double*);
extern struct farray* __esc_module_MOD_ec_yx(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_lapla_es(struct farray*, double*);
extern struct farray* __esc_module_MOD_ec_lapla_ec(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_laplainv_es(struct farray*, double*);
extern struct farray* __esc_module_MOD_ec_laplainv_ec(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_dx_es(struct farray*, double*);
extern struct farray* __esc_module_MOD_ec_dx_ec(struct farray*, double*);
extern struct farray* __esc_module_MOD_ec_dy_es(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_dy_ec(struct farray*, double*);
extern struct farray* __esc_module_MOD_es_jacobian_es_es(struct farray*, double*, double*);
extern struct farray* __esc_module_MOD_ec_jacobian_es_ec(struct farray*, double*, double*);
extern double __esc_module_MOD_intyx_yx(double*);
extern struct farray* __esc_module_MOD_y_intx_yx(struct farray*, double*);
extern struct farray* __esc_module_MOD_x_inty_yx(struct farray*, double*);
extern double __esc_module_MOD_intx_x(double*);
extern double __esc_module_MOD_inty_y(double*);
extern double __esc_module_MOD_avryx_yx(double*);
extern struct farray* __esc_module_MOD_y_avrx_yx(struct farray*, double*);
extern struct farray* __esc_module_MOD_x_avry_yx(struct farray*, double*);
extern double __esc_module_MOD_avrx_x(double*);
extern double __esc_module_MOD_avry_y(double*);
#endif
#ifdef FFC32
asm ("esc_module_x_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_x_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+56, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+28, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_y_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+84, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+112, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.esc_module_+172, %eax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_esc_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 36(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 32(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.esc_initial_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.yx_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.yx_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_lapla_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_lapla_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_lapla_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_lapla_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_laplainv_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_laplainv_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_laplainv_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_laplainv_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_dx_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_dx_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_dx_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_dx_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_dy_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_dy_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_dy_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_dy_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_jacobian_es_es_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.es_jacobian_es_es_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_jacobian_es_ec_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.ec_jacobian_es_ec_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_intyx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.intyx_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_intx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.y_intx_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_inty_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.x_inty_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_intx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.intx_x_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_inty_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.inty_y_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avryx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.avryx_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_avrx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.y_avrx_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_avry_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.x_avry_yx_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avrx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.avrx_x_");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avry_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call esc_module.avry_y_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("esc_module_x_x_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_x_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 112(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_y_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 56(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_y_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 168(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 224(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_y_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.esc_module_@GOTPCREL(%rip), %rax");
asm ("  movq 344(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("esc_module_esc_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $32,%rsp");
asm ("  movq %rbx,-8(%rbp)");
asm ("  movq 16(%rbp),%r10");
asm ("  movq %r10,0(%rsp)");
asm ("  movq 24(%rbp),%r10");
asm ("  movq %r10,8(%rsp)");
asm ("  call esc_module.esc_initial_@PLT");
asm ("  movq -8(%rbp),%rbx");
asm ("  xorq %rax,%rax");
asm ("  addq $32,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.yx_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_yx_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.yx_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_lapla_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_lapla_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_lapla_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_lapla_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_laplainv_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_laplainv_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_laplainv_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_laplainv_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_dx_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_dx_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_dx_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_dx_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_dy_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_dy_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_dy_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_dy_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_es_jacobian_es_es_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.es_jacobian_es_es_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_ec_jacobian_es_ec_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.ec_jacobian_es_ec_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_intyx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.intyx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_intx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.y_intx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_inty_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.x_inty_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_intx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.intx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_inty_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.inty_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avryx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.avryx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_y_avrx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.y_avrx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_x_avry_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.x_avry_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avrx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.avrx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("esc_module_avry_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call esc_module.avry_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* esc_module_x_x_();
extern double* esc_module_x_x_weight_();
extern double* esc_module_y_y_();
extern double* esc_module_y_y_weight_();
extern double* esc_module_yx_x_();
extern double* esc_module_yx_y_();
extern void esc_module_esc_initial_(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* esc_module_yx_es_(struct farray*, double*);
extern struct farray* esc_module_yx_ec_(struct farray*, double*);
extern struct farray* esc_module_es_yx_(struct farray*, double*);
extern struct farray* esc_module_ec_yx_(struct farray*, double*);
extern struct farray* esc_module_es_lapla_es_(struct farray*, double*);
extern struct farray* esc_module_ec_lapla_ec_(struct farray*, double*);
extern struct farray* esc_module_es_laplainv_es_(struct farray*, double*);
extern struct farray* esc_module_ec_laplainv_ec_(struct farray*, double*);
extern struct farray* esc_module_es_dx_es_(struct farray*, double*);
extern struct farray* esc_module_ec_dx_ec_(struct farray*, double*);
extern struct farray* esc_module_ec_dy_es_(struct farray*, double*);
extern struct farray* esc_module_es_dy_ec_(struct farray*, double*);
extern struct farray* esc_module_es_jacobian_es_es_(struct farray*, double*, double*);
extern struct farray* esc_module_ec_jacobian_es_ec_(struct farray*, double*, double*);
extern double esc_module_intyx_yx_(double*);
extern struct farray* esc_module_y_intx_yx_(struct farray*, double*);
extern struct farray* esc_module_x_inty_yx_(struct farray*, double*);
extern double esc_module_intx_x_(double*);
extern double esc_module_inty_y_(double*);
extern double esc_module_avryx_yx_(double*);
extern struct farray* esc_module_y_avrx_yx_(struct farray*, double*);
extern struct farray* esc_module_x_avry_yx_(struct farray*, double*);
extern double esc_module_avrx_x_(double*);
extern double esc_module_avry_y_(double*);
#endif


static int im;
static int jm = 8;
static int km;
static int lm = 5;


static VALUE
rbspml_x_X(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_x_x_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_x_x;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_x_x_();
#endif

{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_x_X_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_x_x_weight_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_x_x_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_x_x_weight_();
#endif

{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_y_Y(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_y_y_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_y_y;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_y_y_();
#endif

{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_y_Y_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_y_y_weight_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_y_y_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_y_y_weight_();
#endif

{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_yx_X(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_yx_x_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_yx_x;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_yx_x_();
#endif

{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_yx_Y(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)esc_module_mp_yx_y_;
#elif defined GFORTRAN
  cout = (double*)__esc_module_MOD_yx_y;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)esc_module_yx_y_();
#endif

{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_esc_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, k, l, xmin, xmax, ymin, ymax;
  int ci;
  int cj;
  int ck;
  int cl;
  double cxmin;
  double cxmax;
  double cymin;
  double cymax;

  rb_scan_args(argc, argv, "80", &i, &j, &k, &l, &xmin, &xmax, &ymin, &ymax);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  ck = NUM2INT(k);
  cl = NUM2INT(l);
  cxmin = NUM2DBL(xmin);
  cxmax = NUM2DBL(xmax);
  cymin = NUM2DBL(ymin);
  cymax = NUM2DBL(ymax);
  im = ci;
  jm = cj;
  km = ck;
  lm = cl;

#if defined IFORT
  esc_module_mp_esc_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#elif defined GFORTRAN
  __esc_module_MOD_esc_initial(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#elif defined(FFC32) || defined(FFC64)
  esc_module_esc_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#endif

  return Qnil;
}

static VALUE
rbspml_yx_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es, out;
  double* ces;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &es);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_yx_es_(cout, ces);
#elif defined GFORTRAN
  __esc_module_MOD_yx_es(cout, ces);
#elif defined(FFC32) || defined(FFC64)
  esc_module_yx_es_(cout, ces);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_yx_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE ec, out;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ec);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_yx_ec_(cout, cec);
#elif defined GFORTRAN
  __esc_module_MOD_yx_ec(cout, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_yx_ec_(cout, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_es_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_ec_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_Lapla_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es, out;
  double* ces;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &es);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_lapla_es_(cout, ces);
#elif defined GFORTRAN
  __esc_module_MOD_es_lapla_es(cout, ces);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_lapla_es_(cout, ces);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_Lapla_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE ec, out;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ec);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_lapla_ec_(cout, cec);
#elif defined GFORTRAN
  __esc_module_MOD_ec_lapla_ec(cout, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_lapla_ec_(cout, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_LaplaInv_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es, out;
  double* ces;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &es);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_laplainv_es_(cout, ces);
#elif defined GFORTRAN
  __esc_module_MOD_es_laplainv_es(cout, ces);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_laplainv_es_(cout, ces);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_LaplaInv_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE ec, out;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ec);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_laplainv_ec_(cout, cec);
#elif defined GFORTRAN
  __esc_module_MOD_ec_laplainv_ec(cout, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_laplainv_ec_(cout, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_Dx_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es, out;
  double* ces;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &es);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_dx_es_(cout, ces);
#elif defined GFORTRAN
  __esc_module_MOD_es_dx_es(cout, ces);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_dx_es_(cout, ces);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_Dx_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE ec, out;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ec);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_dx_ec_(cout, cec);
#elif defined GFORTRAN
  __esc_module_MOD_ec_dx_ec(cout, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_dx_ec_(cout, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_Dy_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es, out;
  double* ces;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &es);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_dy_es_(cout, ces);
#elif defined GFORTRAN
  __esc_module_MOD_ec_dy_es(cout, ces);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_dy_es_(cout, ces);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_Dy_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE ec, out;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ec);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_dy_ec_(cout, cec);
#elif defined GFORTRAN
  __esc_module_MOD_es_dy_ec(cout, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_dy_ec_(cout, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_es_Jacobian_es_es(int argc, VALUE *argv, VALUE self)
{
  VALUE es_a, es_b, out;
  double* ces_a;
  double* ces_b;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &es_a, &es_b);
  es_a = na_cast_object(es_a, NA_DFLOAT);
  ces_a = NA_PTR_TYPE(es_a, double*);
  es_b = na_cast_object(es_b, NA_DFLOAT);
  ces_b = NA_PTR_TYPE(es_b, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = lm;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_es_jacobian_es_es_(cout, ces_a, ces_b);
#elif defined GFORTRAN
  __esc_module_MOD_es_jacobian_es_es(cout, ces_a, ces_b);
#elif defined(FFC32) || defined(FFC64)
  esc_module_es_jacobian_es_es_(cout, ces_a, ces_b);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ec_Jacobian_es_ec(int argc, VALUE *argv, VALUE self)
{
  VALUE es, ec, out;
  double* ces;
  double* cec;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &es, &ec);
  es = na_cast_object(es, NA_DFLOAT);
  ces = NA_PTR_TYPE(es, double*);
  ec = na_cast_object(ec, NA_DFLOAT);
  cec = NA_PTR_TYPE(ec, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_ec_jacobian_es_ec_(cout, ces, cec);
#elif defined GFORTRAN
  __esc_module_MOD_ec_jacobian_es_ec(cout, ces, cec);
#elif defined(FFC32) || defined(FFC64)
  esc_module_ec_jacobian_es_ec_(cout, ces, cec);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = esc_module_mp_intyx_yx_(cyx);
#elif defined GFORTRAN
  cout = __esc_module_MOD_intyx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_intyx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_IntX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_y_intx_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_y_intx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_y_intx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_IntY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_x_inty_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_x_inty_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_x_inty_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = esc_module_mp_intx_x_(cx);
#elif defined GFORTRAN
  cout = __esc_module_MOD_intx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_intx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_IntY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = esc_module_mp_inty_y_(cy);
#elif defined GFORTRAN
  cout = __esc_module_MOD_inty_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_inty_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = esc_module_mp_avryx_yx_(cyx);
#elif defined GFORTRAN
  cout = __esc_module_MOD_avryx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_avryx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_AvrX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_y_avrx_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_y_avrx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_y_avrx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_AvrY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  esc_module_mp_x_avry_yx_(cout, cyx);
#elif defined GFORTRAN
  __esc_module_MOD_x_avry_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  esc_module_x_avry_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_AvrX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = esc_module_mp_avrx_x_(cx);
#elif defined GFORTRAN
  cout = __esc_module_MOD_avrx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_avrx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = esc_module_mp_avry_y_(cy);
#elif defined GFORTRAN
  cout = __esc_module_MOD_avry_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = esc_module_avry_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}


void init_esc_module(VALUE mSPML)
{
  VALUE mESC;

  mESC = rb_define_module_under(mSPML, "ESC");

  rb_define_module_function(mESC, "x_X", rbspml_x_X, -1);
  rb_define_method(mESC, "x_X", rbspml_x_X, -1);
  rb_define_module_function(mESC, "x_X_Weight", rbspml_x_X_Weight, -1);
  rb_define_method(mESC, "x_X_Weight", rbspml_x_X_Weight, -1);
  rb_define_module_function(mESC, "y_Y", rbspml_y_Y, -1);
  rb_define_method(mESC, "y_Y", rbspml_y_Y, -1);
  rb_define_module_function(mESC, "y_Y_Weight", rbspml_y_Y_Weight, -1);
  rb_define_method(mESC, "y_Y_Weight", rbspml_y_Y_Weight, -1);
  rb_define_module_function(mESC, "yx_X", rbspml_yx_X, -1);
  rb_define_method(mESC, "yx_X", rbspml_yx_X, -1);
  rb_define_module_function(mESC, "yx_Y", rbspml_yx_Y, -1);
  rb_define_method(mESC, "yx_Y", rbspml_yx_Y, -1);
  rb_define_module_function(mESC, "initial", rbspml_esc_Initial, -1);
  rb_define_method(mESC, "initial", rbspml_esc_Initial, -1);
  rb_define_module_function(mESC, "yx_es", rbspml_yx_es, -1);
  rb_define_method(mESC, "yx_es", rbspml_yx_es, -1);
  rb_define_module_function(mESC, "yx_ec", rbspml_yx_ec, -1);
  rb_define_method(mESC, "yx_ec", rbspml_yx_ec, -1);
  rb_define_module_function(mESC, "es_yx", rbspml_es_yx, -1);
  rb_define_method(mESC, "es_yx", rbspml_es_yx, -1);
  rb_define_module_function(mESC, "ec_yx", rbspml_ec_yx, -1);
  rb_define_method(mESC, "ec_yx", rbspml_ec_yx, -1);
  rb_define_module_function(mESC, "es_Lapla_es", rbspml_es_Lapla_es, -1);
  rb_define_method(mESC, "es_Lapla_es", rbspml_es_Lapla_es, -1);
  rb_define_module_function(mESC, "ec_Lapla_ec", rbspml_ec_Lapla_ec, -1);
  rb_define_method(mESC, "ec_Lapla_ec", rbspml_ec_Lapla_ec, -1);
  rb_define_module_function(mESC, "es_LaplaInv_es", rbspml_es_LaplaInv_es, -1);
  rb_define_method(mESC, "es_LaplaInv_es", rbspml_es_LaplaInv_es, -1);
  rb_define_module_function(mESC, "ec_LaplaInv_ec", rbspml_ec_LaplaInv_ec, -1);
  rb_define_method(mESC, "ec_LaplaInv_ec", rbspml_ec_LaplaInv_ec, -1);
  rb_define_module_function(mESC, "es_Dx_es", rbspml_es_Dx_es, -1);
  rb_define_method(mESC, "es_Dx_es", rbspml_es_Dx_es, -1);
  rb_define_module_function(mESC, "ec_Dx_ec", rbspml_ec_Dx_ec, -1);
  rb_define_method(mESC, "ec_Dx_ec", rbspml_ec_Dx_ec, -1);
  rb_define_module_function(mESC, "ec_Dy_es", rbspml_ec_Dy_es, -1);
  rb_define_method(mESC, "ec_Dy_es", rbspml_ec_Dy_es, -1);
  rb_define_module_function(mESC, "es_Dy_ec", rbspml_es_Dy_ec, -1);
  rb_define_method(mESC, "es_Dy_ec", rbspml_es_Dy_ec, -1);
  rb_define_module_function(mESC, "es_Jacobian_es_es", rbspml_es_Jacobian_es_es, -1);
  rb_define_method(mESC, "es_Jacobian_es_es", rbspml_es_Jacobian_es_es, -1);
  rb_define_module_function(mESC, "ec_Jacobian_es_ec", rbspml_ec_Jacobian_es_ec, -1);
  rb_define_method(mESC, "ec_Jacobian_es_ec", rbspml_ec_Jacobian_es_ec, -1);
  rb_define_module_function(mESC, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_method(mESC, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_module_function(mESC, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_method(mESC, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_module_function(mESC, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_method(mESC, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_module_function(mESC, "IntX_x", rbspml_IntX_x, -1);
  rb_define_method(mESC, "IntX_x", rbspml_IntX_x, -1);
  rb_define_module_function(mESC, "IntY_y", rbspml_IntY_y, -1);
  rb_define_method(mESC, "IntY_y", rbspml_IntY_y, -1);
  rb_define_module_function(mESC, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_method(mESC, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_module_function(mESC, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_method(mESC, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_module_function(mESC, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_method(mESC, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_module_function(mESC, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_method(mESC, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_module_function(mESC, "AvrY_y", rbspml_AvrY_y, -1);
  rb_define_method(mESC, "AvrY_y", rbspml_AvrY_y, -1);
}
