#include "ruby-spml.h"

#ifdef IFORT
extern double* ee_module_mp_x_x_;
extern double* ee_module_mp_x_x_weight_;
extern double* ee_module_mp_y_y_;
extern double* ee_module_mp_y_y_weight_;
extern double* ee_module_mp_yx_x_;
extern double* ee_module_mp_yx_y_;
extern void ee_module_mp_ee_initial_(int*, int*, int*, int*, double*, double*, double*, double*, int*);
extern void ee_module_mp_ee_changeresolutiondomain_(int*);
extern struct farray* ee_module_mp_yx_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_yx_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_lapla_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_laplainv_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_dx_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_dy_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_jacobian_ee_ee_(struct farray*, double*, double*);
extern struct farray* ee_module_mp_ee_jacobianz_ee_(struct farray*, double*);
extern double ee_module_mp_intyx_yx_(double*);
extern struct farray* ee_module_mp_y_intx_yx_(struct farray*, double*);
extern struct farray* ee_module_mp_x_inty_yx_(struct farray*, double*);
extern double ee_module_mp_intx_x_(double*);
extern double ee_module_mp_inty_y_(double*);
extern double ee_module_mp_avryx_yx_(double*);
extern struct farray* ee_module_mp_y_avrx_yx_(struct farray*, double*);
extern struct farray* ee_module_mp_x_avry_yx_(struct farray*, double*);
extern double ee_module_mp_avrx_x_(double*);
extern double ee_module_mp_avry_y_(double*);
extern struct farray* ee_module_mp_ee_energyfromstreamfunc_ee_(struct farray*, double*);
extern struct farray* ee_module_mp_ee_enstrophyfromstreamfunc_ee_(struct farray*, double*);
extern double ee_module_mp_interpolate_ee_(double*, double*, double*);
#endif
#ifdef GFORTRAN
extern double* __ee_module_MOD_x_x;
extern double* __ee_module_MOD_x_x_weight;
extern double* __ee_module_MOD_y_y;
extern double* __ee_module_MOD_y_y_weight;
extern double* __ee_module_MOD_yx_x;
extern double* __ee_module_MOD_yx_y;
extern void __ee_module_MOD_ee_initial(int*, int*, int*, int*, double*, double*, double*, double*, int*);
extern void __ee_module_MOD_ee_changeresolutiondomain(int*);
extern struct farray* __ee_module_MOD_yx_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_yx(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_lapla_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_laplainv_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_dx_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_dy_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_jacobian_ee_ee(struct farray*, double*, double*);
extern struct farray* __ee_module_MOD_ee_jacobianz_ee(struct farray*, double*);
extern double __ee_module_MOD_intyx_yx(double*);
extern struct farray* __ee_module_MOD_y_intx_yx(struct farray*, double*);
extern struct farray* __ee_module_MOD_x_inty_yx(struct farray*, double*);
extern double __ee_module_MOD_intx_x(double*);
extern double __ee_module_MOD_inty_y(double*);
extern double __ee_module_MOD_avryx_yx(double*);
extern struct farray* __ee_module_MOD_y_avrx_yx(struct farray*, double*);
extern struct farray* __ee_module_MOD_x_avry_yx(struct farray*, double*);
extern double __ee_module_MOD_avrx_x(double*);
extern double __ee_module_MOD_avry_y(double*);
extern struct farray* __ee_module_MOD_ee_energyfromstreamfunc_ee(struct farray*, double*);
extern struct farray* __ee_module_MOD_ee_enstrophyfromstreamfunc_ee(struct farray*, double*);
extern double __ee_module_MOD_interpolate_ee(double*, double*, double*);
#endif
#ifdef FFC32
asm ("ee_module_x_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_x_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+56, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+28, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_y_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+84, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+112, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.ee_module_+172, %eax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 40(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 36(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 32(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_initial_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_changeresolutiondomain_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_changeresolutiondomain_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.yx_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_lapla_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_lapla_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_laplainv_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_laplainv_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_dx_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_dx_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_dy_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_dy_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_jacobian_ee_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_jacobian_ee_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_jacobianz_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_jacobianz_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_intyx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.intyx_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_intx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.y_intx_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_inty_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.x_inty_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_intx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.intx_x_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_inty_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.inty_y_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avryx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.avryx_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_avrx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.y_avrx_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_avry_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.x_avry_yx_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avrx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.avrx_x_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avry_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.avry_y_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_energyfromstreamfunc_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_energyfromstreamfunc_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_enstrophyfromstreamfunc_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.ee_enstrophyfromstreamfunc_ee_");
asm ("  leave");
asm ("  ret");
asm ("ee_module_interpolate_ee_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call ee_module.interpolate_ee_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("ee_module_x_x_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_x_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 112(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_y_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 56(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_y_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 168(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 224(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_y_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.ee_module_@GOTPCREL(%rip), %rax");
asm ("  movq 344(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $64,%rsp");
asm ("  movq %rbx,-8(%rbp)");
asm ("  movq 16(%rbp),%r10");
asm ("  movq %r10,0(%rsp)");
asm ("  movq 24(%rbp),%r10");
asm ("  movq %r10,8(%rsp)");
asm ("  movq 32(%rbp),%r10");
asm ("  movq %r10,16(%rsp)");
asm ("  call ee_module.ee_initial_@PLT");
asm ("  movq -8(%rbp),%rbx");
asm ("  xorq %rax,%rax");
asm ("  addq $64,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_changeresolutiondomain_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_changeresolutiondomain_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_yx_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.yx_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_lapla_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_lapla_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_laplainv_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_laplainv_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_dx_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_dx_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_dy_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_dy_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_jacobian_ee_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_jacobian_ee_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_jacobianz_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_jacobianz_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_intyx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.intyx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_intx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.y_intx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_inty_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.x_inty_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_intx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.intx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_inty_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.inty_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avryx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.avryx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_y_avrx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.y_avrx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_x_avry_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.x_avry_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avrx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.avrx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_avry_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.avry_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_energyfromstreamfunc_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_energyfromstreamfunc_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_ee_enstrophyfromstreamfunc_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.ee_enstrophyfromstreamfunc_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("ee_module_interpolate_ee_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call ee_module.interpolate_ee_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* ee_module_x_x_();
extern double* ee_module_x_x_weight_();
extern double* ee_module_y_y_();
extern double* ee_module_y_y_weight_();
extern double* ee_module_yx_x_();
extern double* ee_module_yx_y_();
extern void ee_module_ee_initial_(int*, int*, int*, int*, double*, double*, double*, double*, int*);
extern void ee_module_ee_changeresolutiondomain_(int*);
extern struct farray* ee_module_yx_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_yx_(struct farray*, double*);
extern struct farray* ee_module_ee_lapla_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_laplainv_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_dx_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_dy_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_jacobian_ee_ee_(struct farray*, double*, double*);
extern struct farray* ee_module_ee_jacobianz_ee_(struct farray*, double*);
extern double ee_module_intyx_yx_(double*);
extern struct farray* ee_module_y_intx_yx_(struct farray*, double*);
extern struct farray* ee_module_x_inty_yx_(struct farray*, double*);
extern double ee_module_intx_x_(double*);
extern double ee_module_inty_y_(double*);
extern double ee_module_avryx_yx_(double*);
extern struct farray* ee_module_y_avrx_yx_(struct farray*, double*);
extern struct farray* ee_module_x_avry_yx_(struct farray*, double*);
extern double ee_module_avrx_x_(double*);
extern double ee_module_avry_y_(double*);
extern struct farray* ee_module_ee_energyfromstreamfunc_ee_(struct farray*, double*);
extern struct farray* ee_module_ee_enstrophyfromstreamfunc_ee_(struct farray*, double*);
extern double ee_module_interpolate_ee_(double*, double*, double*);
#endif


static int im;
static int jm;
static int km;
static int lm;
struct ee_param {
  int im, jm, km, lm;
};
static struct ee_param params[10];
static int nparams = -1;


static VALUE
rbspml_x_X(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_x_x_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_x_x;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_x_x_();
#endif

{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_x_X_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_x_x_weight_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_x_x_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_x_x_weight_();
#endif

{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_y_Y(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_y_y_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_y_y;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_y_y_();
#endif

{
  int shape[1];
  shape[0] = (jm-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_y_Y_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_y_y_weight_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_y_y_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_y_y_weight_();
#endif

{
  int shape[1];
  shape[0] = (jm-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_yx_X(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_yx_x_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_yx_x;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_yx_x_();
#endif

{
  int shape[2];
  shape[0] = (jm-1) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_yx_Y(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)ee_module_mp_yx_y_;
#elif defined GFORTRAN
  cout = (double*)__ee_module_MOD_yx_y;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)ee_module_yx_y_();
#endif

{
  int shape[2];
  shape[0] = (jm-1) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_ee_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, k, l, xmin, xmax, ymin, ymax, id;
  int ci;
  int cj;
  int ck;
  int cl;
  double cxmin;
  double cxmax;
  double cymin;
  double cymax;
  int cid;

  rb_scan_args(argc, argv, "80", &i, &j, &k, &l, &xmin, &xmax, &ymin, &ymax);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  ck = NUM2INT(k);
  cl = NUM2INT(l);
  cxmin = NUM2DBL(xmin);
  cxmax = NUM2DBL(xmax);
  cymin = NUM2DBL(ymin);
  cymax = NUM2DBL(ymax);
  im = ci;
  jm = cj;
  km = ck;
  lm = cl;
  nparams = nparams + 1;
  params[nparams].im = im;
  params[nparams].jm = jm;
  params[nparams].km = km;
  params[nparams].lm = lm;

#if defined IFORT
  ee_module_mp_ee_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax, &cid);
#elif defined GFORTRAN
  __ee_module_MOD_ee_initial(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax, &cid);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax, &cid);
#endif

  id = INT2NUM(cid);
  return id;
}

static VALUE
rbspml_ee_ChangeResolutionDomain(int argc, VALUE *argv, VALUE self)
{
  VALUE id;
  int cid;

  rb_scan_args(argc, argv, "10", &id);
  cid = NUM2INT(id);
  im = params[cid-1].im;
  jm = params[cid-1].jm;
  km = params[cid-1].km;
  lm = params[cid-1].lm;

#if defined IFORT
  ee_module_mp_ee_changeresolutiondomain_(&cid);
#elif defined GFORTRAN
  __ee_module_MOD_ee_changeresolutiondomain(&cid);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_changeresolutiondomain_(&cid);
#endif

  return Qnil;
}

static VALUE
rbspml_yx_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee, out;
  double* cee;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee);
  ee = na_cast_object(ee, NA_DFLOAT);
  cee = NA_PTR_TYPE(ee, double*);
{
  int shape[2];
  shape[0] = (jm-1) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_yx_ee_(cout, cee);
#elif defined GFORTRAN
  __ee_module_MOD_yx_ee(cout, cee);
#elif defined(FFC32) || defined(FFC64)
  ee_module_yx_ee_(cout, cee);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_yx_(cout, cyx);
#elif defined GFORTRAN
  __ee_module_MOD_ee_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_Lapla_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee, out;
  double* cee;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee);
  ee = na_cast_object(ee, NA_DFLOAT);
  cee = NA_PTR_TYPE(ee, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_lapla_ee_(cout, cee);
#elif defined GFORTRAN
  __ee_module_MOD_ee_lapla_ee(cout, cee);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_lapla_ee_(cout, cee);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_LaplaInv_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee, out;
  double* cee;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee);
  ee = na_cast_object(ee, NA_DFLOAT);
  cee = NA_PTR_TYPE(ee, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_laplainv_ee_(cout, cee);
#elif defined GFORTRAN
  __ee_module_MOD_ee_laplainv_ee(cout, cee);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_laplainv_ee_(cout, cee);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_Dx_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee, out;
  double* cee;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee);
  ee = na_cast_object(ee, NA_DFLOAT);
  cee = NA_PTR_TYPE(ee, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_dx_ee_(cout, cee);
#elif defined GFORTRAN
  __ee_module_MOD_ee_dx_ee(cout, cee);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_dx_ee_(cout, cee);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_Dy_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee, out;
  double* cee;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee);
  ee = na_cast_object(ee, NA_DFLOAT);
  cee = NA_PTR_TYPE(ee, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_dy_ee_(cout, cee);
#elif defined GFORTRAN
  __ee_module_MOD_ee_dy_ee(cout, cee);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_dy_ee_(cout, cee);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_Jacobian_ee_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee_a, ee_b, out;
  double* cee_a;
  double* cee_b;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &ee_a, &ee_b);
  ee_a = na_cast_object(ee_a, NA_DFLOAT);
  cee_a = NA_PTR_TYPE(ee_a, double*);
  ee_b = na_cast_object(ee_b, NA_DFLOAT);
  cee_b = NA_PTR_TYPE(ee_b, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_jacobian_ee_ee_(cout, cee_a, cee_b);
#elif defined GFORTRAN
  __ee_module_MOD_ee_jacobian_ee_ee(cout, cee_a, cee_b);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_jacobian_ee_ee_(cout, cee_a, cee_b);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_JacobianZ_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee_zeta, out;
  double* cee_zeta;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee_zeta);
  ee_zeta = na_cast_object(ee_zeta, NA_DFLOAT);
  cee_zeta = NA_PTR_TYPE(ee_zeta, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_jacobianz_ee_(cout, cee_zeta);
#elif defined GFORTRAN
  __ee_module_MOD_ee_jacobianz_ee(cout, cee_zeta);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_jacobianz_ee_(cout, cee_zeta);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = ee_module_mp_intyx_yx_(cyx);
#elif defined GFORTRAN
  cout = __ee_module_MOD_intyx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_intyx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_IntX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_y_intx_yx_(cout, cyx);
#elif defined GFORTRAN
  __ee_module_MOD_y_intx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  ee_module_y_intx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_IntY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_x_inty_yx_(cout, cyx);
#elif defined GFORTRAN
  __ee_module_MOD_x_inty_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  ee_module_x_inty_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = ee_module_mp_intx_x_(cx);
#elif defined GFORTRAN
  cout = __ee_module_MOD_intx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_intx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_IntY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = ee_module_mp_inty_y_(cy);
#elif defined GFORTRAN
  cout = __ee_module_MOD_inty_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_inty_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = ee_module_mp_avryx_yx_(cyx);
#elif defined GFORTRAN
  cout = __ee_module_MOD_avryx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_avryx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_AvrX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_y_avrx_yx_(cout, cyx);
#elif defined GFORTRAN
  __ee_module_MOD_y_avrx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  ee_module_y_avrx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_AvrY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_x_avry_yx_(cout, cyx);
#elif defined GFORTRAN
  __ee_module_MOD_x_avry_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  ee_module_x_avry_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_AvrX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = ee_module_mp_avrx_x_(cx);
#elif defined GFORTRAN
  cout = __ee_module_MOD_avrx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_avrx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = ee_module_mp_avry_y_(cy);
#elif defined GFORTRAN
  cout = __ee_module_MOD_avry_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_avry_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_ee_EnergyFromStreamfunc_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee_strfunc, out;
  double* cee_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee_strfunc);
  ee_strfunc = na_cast_object(ee_strfunc, NA_DFLOAT);
  cee_strfunc = NA_PTR_TYPE(ee_strfunc, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_energyfromstreamfunc_ee_(cout, cee_strfunc);
#elif defined GFORTRAN
  __ee_module_MOD_ee_energyfromstreamfunc_ee(cout, cee_strfunc);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_energyfromstreamfunc_ee_(cout, cee_strfunc);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ee_EnstrophyFromStreamfunc_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee_strfunc, out;
  double* cee_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &ee_strfunc);
  ee_strfunc = na_cast_object(ee_strfunc, NA_DFLOAT);
  cee_strfunc = NA_PTR_TYPE(ee_strfunc, double*);
{
  int shape[2];
  shape[0] = (lm) - (-lm) + 1;
  shape[1] = (km) - (-km) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  ee_module_mp_ee_enstrophyfromstreamfunc_ee_(cout, cee_strfunc);
#elif defined GFORTRAN
  __ee_module_MOD_ee_enstrophyfromstreamfunc_ee(cout, cee_strfunc);
#elif defined(FFC32) || defined(FFC64)
  ee_module_ee_enstrophyfromstreamfunc_ee_(cout, cee_strfunc);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_Interpolate_ee(int argc, VALUE *argv, VALUE self)
{
  VALUE ee_data, x, y, out;
  double* cee_data;
  double cx;
  double cy;
  double cout;

  rb_scan_args(argc, argv, "30", &ee_data, &x, &y);
  ee_data = na_cast_object(ee_data, NA_DFLOAT);
  cee_data = NA_PTR_TYPE(ee_data, double*);
  cx = NUM2DBL(x);
  cy = NUM2DBL(y);

#if defined IFORT
  cout = ee_module_mp_interpolate_ee_(cee_data, &cx, &cy);
#elif defined GFORTRAN
  cout = __ee_module_MOD_interpolate_ee(cee_data, &cx, &cy);
#elif defined(FFC32) || defined(FFC64)
  cout = ee_module_interpolate_ee_(cee_data, &cx, &cy);
#endif

  out = rb_float_new(cout);
  return out;
}


void init_ee_module(VALUE mSPML)
{
  VALUE mEE;

  mEE = rb_define_module_under(mSPML, "EE");

  rb_define_module_function(mEE, "x_X", rbspml_x_X, -1);
  rb_define_method(mEE, "x_X", rbspml_x_X, -1);
  rb_define_module_function(mEE, "x_X_Weight", rbspml_x_X_Weight, -1);
  rb_define_method(mEE, "x_X_Weight", rbspml_x_X_Weight, -1);
  rb_define_module_function(mEE, "y_Y", rbspml_y_Y, -1);
  rb_define_method(mEE, "y_Y", rbspml_y_Y, -1);
  rb_define_module_function(mEE, "y_Y_Weight", rbspml_y_Y_Weight, -1);
  rb_define_method(mEE, "y_Y_Weight", rbspml_y_Y_Weight, -1);
  rb_define_module_function(mEE, "yx_X", rbspml_yx_X, -1);
  rb_define_method(mEE, "yx_X", rbspml_yx_X, -1);
  rb_define_module_function(mEE, "yx_Y", rbspml_yx_Y, -1);
  rb_define_method(mEE, "yx_Y", rbspml_yx_Y, -1);
  rb_define_module_function(mEE, "initial", rbspml_ee_Initial, -1);
  rb_define_method(mEE, "initial", rbspml_ee_Initial, -1);
  rb_define_module_function(mEE, "ee_ChangeResolutionDomain", rbspml_ee_ChangeResolutionDomain, -1);
  rb_define_method(mEE, "ee_ChangeResolutionDomain", rbspml_ee_ChangeResolutionDomain, -1);
  rb_define_module_function(mEE, "yx_ee", rbspml_yx_ee, -1);
  rb_define_method(mEE, "yx_ee", rbspml_yx_ee, -1);
  rb_define_module_function(mEE, "ee_yx", rbspml_ee_yx, -1);
  rb_define_method(mEE, "ee_yx", rbspml_ee_yx, -1);
  rb_define_module_function(mEE, "ee_Lapla_ee", rbspml_ee_Lapla_ee, -1);
  rb_define_method(mEE, "ee_Lapla_ee", rbspml_ee_Lapla_ee, -1);
  rb_define_module_function(mEE, "ee_LaplaInv_ee", rbspml_ee_LaplaInv_ee, -1);
  rb_define_method(mEE, "ee_LaplaInv_ee", rbspml_ee_LaplaInv_ee, -1);
  rb_define_module_function(mEE, "ee_Dx_ee", rbspml_ee_Dx_ee, -1);
  rb_define_method(mEE, "ee_Dx_ee", rbspml_ee_Dx_ee, -1);
  rb_define_module_function(mEE, "ee_Dy_ee", rbspml_ee_Dy_ee, -1);
  rb_define_method(mEE, "ee_Dy_ee", rbspml_ee_Dy_ee, -1);
  rb_define_module_function(mEE, "ee_Jacobian_ee_ee", rbspml_ee_Jacobian_ee_ee, -1);
  rb_define_method(mEE, "ee_Jacobian_ee_ee", rbspml_ee_Jacobian_ee_ee, -1);
  rb_define_module_function(mEE, "ee_JacobianZ_ee", rbspml_ee_JacobianZ_ee, -1);
  rb_define_method(mEE, "ee_JacobianZ_ee", rbspml_ee_JacobianZ_ee, -1);
  rb_define_module_function(mEE, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_method(mEE, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_module_function(mEE, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_method(mEE, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_module_function(mEE, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_method(mEE, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_module_function(mEE, "IntX_x", rbspml_IntX_x, -1);
  rb_define_method(mEE, "IntX_x", rbspml_IntX_x, -1);
  rb_define_module_function(mEE, "IntY_y", rbspml_IntY_y, -1);
  rb_define_method(mEE, "IntY_y", rbspml_IntY_y, -1);
  rb_define_module_function(mEE, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_method(mEE, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_module_function(mEE, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_method(mEE, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_module_function(mEE, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_method(mEE, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_module_function(mEE, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_method(mEE, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_module_function(mEE, "AvrY_y", rbspml_AvrY_y, -1);
  rb_define_method(mEE, "AvrY_y", rbspml_AvrY_y, -1);
  rb_define_module_function(mEE, "ee_EnergyFromStreamfunc_ee", rbspml_ee_EnergyFromStreamfunc_ee, -1);
  rb_define_method(mEE, "ee_EnergyFromStreamfunc_ee", rbspml_ee_EnergyFromStreamfunc_ee, -1);
  rb_define_module_function(mEE, "ee_EnstrophyFromStreamfunc_ee", rbspml_ee_EnstrophyFromStreamfunc_ee, -1);
  rb_define_method(mEE, "ee_EnstrophyFromStreamfunc_ee", rbspml_ee_EnstrophyFromStreamfunc_ee, -1);
  rb_define_module_function(mEE, "Interpolate_ee", rbspml_Interpolate_ee, -1);
  rb_define_method(mEE, "Interpolate_ee", rbspml_Interpolate_ee, -1);
}
