#include "ruby-spml.h"

#ifdef IFORT
extern double* et_module_mp_yx_x_;
extern double* et_module_mp_yx_y_;
extern void et_module_mp_et_initial_(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* et_module_mp_yx_et_(struct farray*, double*);
extern struct farray* et_module_mp_et_yx_(struct farray*, double*);
extern struct farray* et_module_mp_et_dx_et_(struct farray*, double*);
extern struct farray* et_module_mp_et_dy_et_(struct farray*, double*);
extern struct farray* et_module_mp_et_lapla_et_(struct farray*, double*);
extern struct farray* et_module_mp_et_jacobian_et_et_(struct farray*, double*, double*);
extern void et_module_mp_et_boundaries_(double*, double*, char*);
extern struct farray* et_module_mp_et_laplainv_et_(struct farray*, double*, double*);
extern struct farray* et_module_mp_ey_vor2strm_ey_(struct farray*, double*, double*, char*, int*);
extern struct farray* et_module_mp_et_vor2strm_et_(struct farray*, double*, double*, int*);
extern struct farray* et_module_mp_et_vor2strm1_et_(struct farray*, double*, double*, int*);
extern double et_module_mp_intyx_yx_(double*);
extern struct farray* et_module_mp_y_intx_yx_(struct farray*, double*);
extern struct farray* et_module_mp_x_inty_yx_(struct farray*, double*);
extern double et_module_mp_intx_x_(double*);
extern double et_module_mp_inty_y_(double*);
extern double et_module_mp_avryx_yx_(double*);
extern struct farray* et_module_mp_y_avrx_yx_(struct farray*, double*);
extern struct farray* et_module_mp_x_avry_yx_(struct farray*, double*);
extern double et_module_mp_avrx_x_(double*);
extern double et_module_mp_avry_y_(double*);
#endif
#ifdef GFORTRAN
extern double* __et_module_MOD_yx_x;
extern double* __et_module_MOD_yx_y;
extern void __et_module_MOD_et_initial(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* __et_module_MOD_yx_et(struct farray*, double*);
extern struct farray* __et_module_MOD_et_yx(struct farray*, double*);
extern struct farray* __et_module_MOD_et_dx_et(struct farray*, double*);
extern struct farray* __et_module_MOD_et_dy_et(struct farray*, double*);
extern struct farray* __et_module_MOD_et_lapla_et(struct farray*, double*);
extern struct farray* __et_module_MOD_et_jacobian_et_et(struct farray*, double*, double*);
extern void __et_module_MOD_et_boundaries(double*, double*, char*);
extern struct farray* __et_module_MOD_et_laplainv_et(struct farray*, double*, double*);
extern struct farray* __et_module_MOD_ey_vor2strm_ey(struct farray*, double*, double*, char*, int*);
extern struct farray* __et_module_MOD_et_vor2strm_et(struct farray*, double*, double*, int*);
extern struct farray* __et_module_MOD_et_vor2strm1_et(struct farray*, double*, double*, int*);
extern double __et_module_MOD_intyx_yx(double*);
extern struct farray* __et_module_MOD_y_intx_yx(struct farray*, double*);
extern struct farray* __et_module_MOD_x_inty_yx(struct farray*, double*);
extern double __et_module_MOD_intx_x(double*);
extern double __et_module_MOD_inty_y(double*);
extern double __et_module_MOD_avryx_yx(double*);
extern struct farray* __et_module_MOD_y_avrx_yx(struct farray*, double*);
extern struct farray* __et_module_MOD_x_avry_yx(struct farray*, double*);
extern double __et_module_MOD_avrx_x(double*);
extern double __et_module_MOD_avry_y(double*);
#endif
#ifdef FFC32
asm ("et_module_yx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.et_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("et_module_yx_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.et_module_+60, %eax");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 36(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 32(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 28(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_initial_");
asm ("  leave");
asm ("  ret");
asm ("et_module_yx_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.yx_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_dx_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_dx_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_dy_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_dy_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_lapla_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_lapla_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_jacobian_et_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_jacobian_et_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_boundaries_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_boundaries_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_laplainv_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_laplainv_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_ey_vor2strm_ey_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.ey_vor2strm_ey_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_vor2strm_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_vor2strm_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_vor2strm1_et_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.et_vor2strm1_et_");
asm ("  leave");
asm ("  ret");
asm ("et_module_intyx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.intyx_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_y_intx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.y_intx_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_x_inty_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.x_inty_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_intx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.intx_x_");
asm ("  leave");
asm ("  ret");
asm ("et_module_inty_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.inty_y_");
asm ("  leave");
asm ("  ret");
asm ("et_module_avryx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.avryx_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_y_avrx_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.y_avrx_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_x_avry_yx_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.x_avry_yx_");
asm ("  leave");
asm ("  ret");
asm ("et_module_avrx_x_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.avrx_x_");
asm ("  leave");
asm ("  ret");
asm ("et_module_avry_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call et_module.avry_y_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("et_module_yx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.et_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("et_module_yx_y_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.et_module_@GOTPCREL(%rip), %rax");
asm ("  movq 120(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $32,%rsp");
asm ("  movq %rbx,-8(%rbp)");
asm ("  movq 16(%rbp),%r10");
asm ("  movq %r10,0(%rsp)");
asm ("  movq 24(%rbp),%r10");
asm ("  movq %r10,8(%rsp)");
asm ("  call et_module.et_initial_@PLT");
asm ("  movq -8(%rbp),%rbx");
asm ("  xorq %rax,%rax");
asm ("  addq $32,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_yx_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.yx_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_dx_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_dx_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_dy_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_dy_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_lapla_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_lapla_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_jacobian_et_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_jacobian_et_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_boundaries_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_boundaries_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_laplainv_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_laplainv_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_ey_vor2strm_ey_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.ey_vor2strm_ey_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_vor2strm_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_vor2strm_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_et_vor2strm1_et_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.et_vor2strm1_et_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_intyx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.intyx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_y_intx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.y_intx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_x_inty_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.x_inty_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_intx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.intx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_inty_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.inty_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_avryx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.avryx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_y_avrx_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.y_avrx_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_x_avry_yx_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.x_avry_yx_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_avrx_x_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.avrx_x_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("et_module_avry_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call et_module.avry_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* et_module_yx_x_();
extern double* et_module_yx_y_();
extern void et_module_et_initial_(int*, int*, int*, int*, double*, double*, double*, double*);
extern struct farray* et_module_yx_et_(struct farray*, double*);
extern struct farray* et_module_et_yx_(struct farray*, double*);
extern struct farray* et_module_et_dx_et_(struct farray*, double*);
extern struct farray* et_module_et_dy_et_(struct farray*, double*);
extern struct farray* et_module_et_lapla_et_(struct farray*, double*);
extern struct farray* et_module_et_jacobian_et_et_(struct farray*, double*, double*);
extern void et_module_et_boundaries_(double*, double*, char*);
extern struct farray* et_module_et_laplainv_et_(struct farray*, double*, double*);
extern struct farray* et_module_ey_vor2strm_ey_(struct farray*, double*, double*, char*, int*);
extern struct farray* et_module_et_vor2strm_et_(struct farray*, double*, double*, int*);
extern struct farray* et_module_et_vor2strm1_et_(struct farray*, double*, double*, int*);
extern double et_module_intyx_yx_(double*);
extern struct farray* et_module_y_intx_yx_(struct farray*, double*);
extern struct farray* et_module_x_inty_yx_(struct farray*, double*);
extern double et_module_intx_x_(double*);
extern double et_module_inty_y_(double*);
extern double et_module_avryx_yx_(double*);
extern struct farray* et_module_y_avrx_yx_(struct farray*, double*);
extern struct farray* et_module_x_avry_yx_(struct farray*, double*);
extern double et_module_avrx_x_(double*);
extern double et_module_avry_y_(double*);
#endif


static int im;
static int jm = 8;
static int km;
static int lm = 5;


static VALUE
rbspml_yx_X(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)et_module_mp_yx_x_;
#elif defined GFORTRAN
  cout = (double*)__et_module_MOD_yx_x;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)et_module_yx_x_();
#endif

{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_yx_Y(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)et_module_mp_yx_y_;
#elif defined GFORTRAN
  cout = (double*)__et_module_MOD_yx_y;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)et_module_yx_y_();
#endif

{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_et_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE i, j, k, l, xmin, xmax, ymin, ymax;
  int ci;
  int cj;
  int ck;
  int cl;
  double cxmin;
  double cxmax;
  double cymin;
  double cymax;

  rb_scan_args(argc, argv, "80", &i, &j, &k, &l, &xmin, &xmax, &ymin, &ymax);
  ci = NUM2INT(i);
  cj = NUM2INT(j);
  ck = NUM2INT(k);
  cl = NUM2INT(l);
  cxmin = NUM2DBL(xmin);
  cxmax = NUM2DBL(xmax);
  cymin = NUM2DBL(ymin);
  cymax = NUM2DBL(ymax);
  im = ci;
  jm = cj;
  km = ck;
  lm = cl;

#if defined IFORT
  et_module_mp_et_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#elif defined GFORTRAN
  __et_module_MOD_et_initial(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_initial_(&ci, &cj, &ck, &cl, &cxmin, &cxmax, &cymin, &cymax);
#endif

  return Qnil;
}

static VALUE
rbspml_yx_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, out;
  double* cet;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &et);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
{
  int shape[2];
  shape[0] = (jm) - (0) + 1;
  shape[1] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_yx_et_(cout, cet);
#elif defined GFORTRAN
  __et_module_MOD_yx_et(cout, cet);
#elif defined(FFC32) || defined(FFC64)
  et_module_yx_et_(cout, cet);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_yx_(cout, cyx);
#elif defined GFORTRAN
  __et_module_MOD_et_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Dx_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, out;
  double* cet;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &et);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_dx_et_(cout, cet);
#elif defined GFORTRAN
  __et_module_MOD_et_dx_et(cout, cet);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_dx_et_(cout, cet);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Dy_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, out;
  double* cet;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &et);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_dy_et_(cout, cet);
#elif defined GFORTRAN
  __et_module_MOD_et_dy_et(cout, cet);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_dy_et_(cout, cet);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Lapla_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, out;
  double* cet;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &et);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_lapla_et_(cout, cet);
#elif defined GFORTRAN
  __et_module_MOD_et_lapla_et(cout, cet);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_lapla_et_(cout, cet);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Jacobian_et_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et_a, et_b, out;
  double* cet_a;
  double* cet_b;
  struct farray* cout;

  rb_scan_args(argc, argv, "20", &et_a, &et_b);
  et_a = na_cast_object(et_a, NA_DFLOAT);
  cet_a = NA_PTR_TYPE(et_a, double*);
  et_b = na_cast_object(et_b, NA_DFLOAT);
  cet_b = NA_PTR_TYPE(et_b, double*);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_jacobian_et_et_(cout, cet_a, cet_b);
#elif defined GFORTRAN
  __et_module_MOD_et_jacobian_et_et(cout, cet_a, cet_b);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_jacobian_et_et_(cout, cet_a, cet_b);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Boundaries(int argc, VALUE *argv, VALUE self)
{
  VALUE et, values, cond;
  double* cet;
  double* cvalues;
  char* ccond;

  rb_scan_args(argc, argv, "12", &et, &values, &cond);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
  if ( values != Qnil )
    values = na_cast_object(values, NA_DFLOAT);
  cvalues = NA_PTR_TYPE(values, double*);

  if ( cond != Qnil )
    ccond = RSTRING_PTR(cond);

#if defined IFORT
  et_module_mp_et_boundaries_(cet, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond);
#elif defined GFORTRAN
  __et_module_MOD_et_boundaries(cet, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_boundaries_(cet, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond);
#endif

  if ( values != Qnil )
    free(cvalues);
  return et;
}

static VALUE
rbspml_et_LaplaInv_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, values, out;
  double* cet;
  double* cvalues;
  struct farray* cout;

  rb_scan_args(argc, argv, "11", &et, &values);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
  if ( values != Qnil )
    values = na_cast_object(values, NA_DFLOAT);
  cvalues = NA_PTR_TYPE(values, double*);

{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_laplainv_et_(cout, cet, values==Qnil ? NULL : cvalues);
#elif defined GFORTRAN
  __et_module_MOD_et_laplainv_et(cout, cet, values==Qnil ? NULL : cvalues);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_laplainv_et_(cout, cet, values==Qnil ? NULL : cvalues);
#endif

  if ( values != Qnil )
    free(cvalues);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_ey_Vor2Strm_ey(int argc, VALUE *argv, VALUE self)
{
  VALUE ey, values, cond, new, out;
  double* cey;
  double* cvalues;
  char* ccond;
  int cnew;
  struct farray* cout;

  rb_scan_args(argc, argv, "13", &ey, &values, &cond, &new);
  ey = na_cast_object(ey, NA_DFLOAT);
  cey = NA_PTR_TYPE(ey, double*);
  if ( values != Qnil )
    values = na_cast_object(values, NA_DFLOAT);
  cvalues = NA_PTR_TYPE(values, double*);

  if ( cond != Qnil )
    ccond = RSTRING_PTR(cond);
  if ( new != Qnil )
    cnew = (new==Qtrue);
{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_ey_vor2strm_ey_(cout, cey, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#elif defined GFORTRAN
  __et_module_MOD_ey_vor2strm_ey(cout, cey, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#elif defined(FFC32) || defined(FFC64)
  et_module_ey_vor2strm_ey_(cout, cey, values==Qnil ? NULL : cvalues, cond==Qnil ? NULL : ccond, new==Qnil ? NULL : &cnew);
#endif

  if ( values != Qnil )
    free(cvalues);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Vor2Strm_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, values, rigid, out;
  double* cet;
  double* cvalues;
  int* crigid;
  struct farray* cout;

  rb_scan_args(argc, argv, "12", &et, &values, &rigid);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
  if ( values != Qnil )
    values = na_cast_object(values, NA_DFLOAT);
  cvalues = NA_PTR_TYPE(values, double*);

  if ( rigid != Qnil )
    rigid = na_cast_object(rigid, NA_LINT);
  crigid = NA_PTR_TYPE(rigid, int*);

{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_vor2strm_et_(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#elif defined GFORTRAN
  __et_module_MOD_et_vor2strm_et(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_vor2strm_et_(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#endif

  if ( values != Qnil )
    free(cvalues);
  if ( rigid != Qnil )
    free(crigid);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_et_Vor2Strm1_et(int argc, VALUE *argv, VALUE self)
{
  VALUE et, values, rigid, out;
  double* cet;
  double* cvalues;
  int* crigid;
  struct farray* cout;

  rb_scan_args(argc, argv, "12", &et, &values, &rigid);
  et = na_cast_object(et, NA_DFLOAT);
  cet = NA_PTR_TYPE(et, double*);
  if ( values != Qnil )
    values = na_cast_object(values, NA_DFLOAT);
  cvalues = NA_PTR_TYPE(values, double*);

  if ( rigid != Qnil )
    rigid = na_cast_object(rigid, NA_LINT);
  crigid = NA_PTR_TYPE(rigid, int*);

{
  int shape[2];
  shape[0] = (km) - (-km) + 1;
  shape[1] = (lm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_et_vor2strm1_et_(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#elif defined GFORTRAN
  __et_module_MOD_et_vor2strm1_et(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#elif defined(FFC32) || defined(FFC64)
  et_module_et_vor2strm1_et_(cout, cet, values==Qnil ? NULL : cvalues, rigid==Qnil ? NULL : crigid);
#endif

  if ( values != Qnil )
    free(cvalues);
  if ( rigid != Qnil )
    free(crigid);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = et_module_mp_intyx_yx_(cyx);
#elif defined GFORTRAN
  cout = __et_module_MOD_intyx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_intyx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_IntX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_y_intx_yx_(cout, cyx);
#elif defined GFORTRAN
  __et_module_MOD_y_intx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  et_module_y_intx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_IntY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_x_inty_yx_(cout, cyx);
#elif defined GFORTRAN
  __et_module_MOD_x_inty_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  et_module_x_inty_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = et_module_mp_intx_x_(cx);
#elif defined GFORTRAN
  cout = __et_module_MOD_intx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_intx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_IntY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = et_module_mp_inty_y_(cy);
#elif defined GFORTRAN
  cout = __et_module_MOD_inty_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_inty_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrYX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  double cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);

#if defined IFORT
  cout = et_module_mp_avryx_yx_(cyx);
#elif defined GFORTRAN
  cout = __et_module_MOD_avryx_yx(cyx);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_avryx_yx_(cyx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_y_AvrX_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (jm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_y_avrx_yx_(cout, cyx);
#elif defined GFORTRAN
  __et_module_MOD_y_avrx_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  et_module_y_avrx_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_x_AvrY_yx(int argc, VALUE *argv, VALUE self)
{
  VALUE yx, out;
  double* cyx;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &yx);
  yx = na_cast_object(yx, NA_DFLOAT);
  cyx = NA_PTR_TYPE(yx, double*);
{
  int shape[1];
  shape[0] = (im-1) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  et_module_mp_x_avry_yx_(cout, cyx);
#elif defined GFORTRAN
  __et_module_MOD_x_avry_yx(cout, cyx);
#elif defined(FFC32) || defined(FFC64)
  et_module_x_avry_yx_(cout, cyx);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_AvrX_x(int argc, VALUE *argv, VALUE self)
{
  VALUE x, out;
  double* cx;
  double cout;

  rb_scan_args(argc, argv, "10", &x);
  x = na_cast_object(x, NA_DFLOAT);
  cx = NA_PTR_TYPE(x, double*);

#if defined IFORT
  cout = et_module_mp_avrx_x_(cx);
#elif defined GFORTRAN
  cout = __et_module_MOD_avrx_x(cx);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_avrx_x_(cx);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrY_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y, out;
  double* cy;
  double cout;

  rb_scan_args(argc, argv, "10", &y);
  y = na_cast_object(y, NA_DFLOAT);
  cy = NA_PTR_TYPE(y, double*);

#if defined IFORT
  cout = et_module_mp_avry_y_(cy);
#elif defined GFORTRAN
  cout = __et_module_MOD_avry_y(cy);
#elif defined(FFC32) || defined(FFC64)
  cout = et_module_avry_y_(cy);
#endif

  out = rb_float_new(cout);
  return out;
}


void init_et_module(VALUE mSPML)
{
  VALUE mET;

  mET = rb_define_module_under(mSPML, "ET");

  rb_define_module_function(mET, "yx_X", rbspml_yx_X, -1);
  rb_define_method(mET, "yx_X", rbspml_yx_X, -1);
  rb_define_module_function(mET, "yx_Y", rbspml_yx_Y, -1);
  rb_define_method(mET, "yx_Y", rbspml_yx_Y, -1);
  rb_define_module_function(mET, "initial", rbspml_et_Initial, -1);
  rb_define_method(mET, "initial", rbspml_et_Initial, -1);
  rb_define_module_function(mET, "yx_et", rbspml_yx_et, -1);
  rb_define_method(mET, "yx_et", rbspml_yx_et, -1);
  rb_define_module_function(mET, "et_yx", rbspml_et_yx, -1);
  rb_define_method(mET, "et_yx", rbspml_et_yx, -1);
  rb_define_module_function(mET, "et_Dx_et", rbspml_et_Dx_et, -1);
  rb_define_method(mET, "et_Dx_et", rbspml_et_Dx_et, -1);
  rb_define_module_function(mET, "et_Dy_et", rbspml_et_Dy_et, -1);
  rb_define_method(mET, "et_Dy_et", rbspml_et_Dy_et, -1);
  rb_define_module_function(mET, "et_Lapla_et", rbspml_et_Lapla_et, -1);
  rb_define_method(mET, "et_Lapla_et", rbspml_et_Lapla_et, -1);
  rb_define_module_function(mET, "et_Jacobian_et_et", rbspml_et_Jacobian_et_et, -1);
  rb_define_method(mET, "et_Jacobian_et_et", rbspml_et_Jacobian_et_et, -1);
  rb_define_module_function(mET, "et_Boundaries", rbspml_et_Boundaries, -1);
  rb_define_method(mET, "et_Boundaries", rbspml_et_Boundaries, -1);
  rb_define_module_function(mET, "et_LaplaInv_et", rbspml_et_LaplaInv_et, -1);
  rb_define_method(mET, "et_LaplaInv_et", rbspml_et_LaplaInv_et, -1);
  rb_define_module_function(mET, "ey_Vor2Strm_ey", rbspml_ey_Vor2Strm_ey, -1);
  rb_define_method(mET, "ey_Vor2Strm_ey", rbspml_ey_Vor2Strm_ey, -1);
  rb_define_module_function(mET, "et_Vor2Strm_et", rbspml_et_Vor2Strm_et, -1);
  rb_define_method(mET, "et_Vor2Strm_et", rbspml_et_Vor2Strm_et, -1);
  rb_define_module_function(mET, "et_Vor2Strm1_et", rbspml_et_Vor2Strm1_et, -1);
  rb_define_method(mET, "et_Vor2Strm1_et", rbspml_et_Vor2Strm1_et, -1);
  rb_define_module_function(mET, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_method(mET, "IntYX_yx", rbspml_IntYX_yx, -1);
  rb_define_module_function(mET, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_method(mET, "y_IntX_yx", rbspml_y_IntX_yx, -1);
  rb_define_module_function(mET, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_method(mET, "x_IntY_yx", rbspml_x_IntY_yx, -1);
  rb_define_module_function(mET, "IntX_x", rbspml_IntX_x, -1);
  rb_define_method(mET, "IntX_x", rbspml_IntX_x, -1);
  rb_define_module_function(mET, "IntY_y", rbspml_IntY_y, -1);
  rb_define_method(mET, "IntY_y", rbspml_IntY_y, -1);
  rb_define_module_function(mET, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_method(mET, "AvrYX_yx", rbspml_AvrYX_yx, -1);
  rb_define_module_function(mET, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_method(mET, "y_AvrX_yx", rbspml_y_AvrX_yx, -1);
  rb_define_module_function(mET, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_method(mET, "x_AvrY_yx", rbspml_x_AvrY_yx, -1);
  rb_define_module_function(mET, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_method(mET, "AvrX_x", rbspml_AvrX_x, -1);
  rb_define_module_function(mET, "AvrY_y", rbspml_AvrY_y, -1);
  rb_define_method(mET, "AvrY_y", rbspml_AvrY_y, -1);
}
