#include "ruby-spml.h"

#ifdef IFORT
extern void w_module_mp_w_initial_(int*, int*, int*, int*);
#endif
#ifdef GFORTRAN
extern void __w_module_MOD_w_initial(int*, int*, int*, int*);
#endif
#ifdef FFC32
asm ("w_module_w_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_module.w_initial_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("w_module_w_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_module.w_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern void w_module_w_initial_(int*, int*, int*, int*);
#endif


static VALUE
rbspml_w_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE n_in, i_in, j_in, np_in;
  int cn_in;
  int ci_in;
  int cj_in;
  int cnp_in;

  rb_scan_args(argc, argv, "31", &n_in, &i_in, &j_in, &np_in);
  cn_in = NUM2INT(n_in);
  ci_in = NUM2INT(i_in);
  cj_in = NUM2INT(j_in);
  if ( np_in != Qnil )
    cnp_in = NUM2INT(np_in);

#if defined IFORT
  w_module_mp_w_initial_(&cn_in, &ci_in, &cj_in, np_in==Qnil ? NULL : &cnp_in);
#elif defined GFORTRAN
  __w_module_MOD_w_initial(&cn_in, &ci_in, &cj_in, np_in==Qnil ? NULL : &cnp_in);
#elif defined(FFC32) || defined(FFC64)
  w_module_w_initial_(&cn_in, &ci_in, &cj_in, np_in==Qnil ? NULL : &cnp_in);
#endif

  return Qnil;
}


void init_w_module(VALUE mSPML)
{
  VALUE mW;

  mW = rb_define_module_under(mSPML, "W");

  rb_define_module_function(mW, "initial", rbspml_w_Initial, -1);
  rb_define_method(mW, "initial", rbspml_w_Initial, -1);
}
